<!doctype html>
<html>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Media Cleaner</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <style></style>
    </head>
    <body>
        
<?php
    $admin_root = "..";
    $site_root = "../..";
    $xml_pathes = [ "../..", "../../pages", "../../services" ];
    $media_pathes = [ "../../media", "../../multimedia" ];

    // ====== Load Functions Libraries ======

    require "$admin_root/script/functions.php";
    require "$admin_root/script/cms.php";
    require "$admin_root/script/xml.php";

    function getMediaLinks($pathes, $site_root) {
    // ----------------------------------------
    // $path = <string> full directory PATH
    // ----------------------------------------
    // Delete folder with it's content
    // ----------------------------------------
        $media_links = [];
        foreach($pathes as $path) {
            // Get files tree list
            if($path == $site_root) {
                $files_list = listDir($path, "xml,?");
            }
            else {
                $files_list = filesTree($path, "xml");
            };
            // Check files links
            foreach($files_list as $file) {
                if($xml = loadXml($file)) {
                    echo "[xml]: $file<br>";
                    //arrayList($xml);
                    foreach(array_keys($xml) as $article_name) {
                        $article_group = $xml[$article_name];
                        foreach(array_keys($article_group) as $article_num) {
                            $article = $article_group[$article_num];
                            foreach(array_keys($article) as $section_name) {
                                $section = $article[$section_name][0];
                                if(isset($section["media"]) && is_array($section["media"])) {
                                    $media = $section["media"][0];
                                    //arrayList($media);
                                    foreach($media as $item) {
                                        foreach(explode(";", $item[0]) as $file) {
                                            //echo "$file"
                                            $filepath = "$site_root/$file";
                                            if(trim($file) != "" && !is_dir($filepath) && file_exists($filepath)) {
                                                if(!in_array($filepath, $media_links)) {
                                                    $media_links[] = $filepath;
                                                }
                                            }
                                        }
                                    };
                                }
                            };
                        };
                    };
                }
            };
        };
        return $media_links;
    };
        
    
        
    function mediaCleaner($pathes, $media_links) {
        $flag = false;
        foreach($pathes as $path) {
            foreach(filesTree($path, ".") as $file) {
                if(!in_array($file, $media_links)) {
                    echo "> $file<br>";
                    unlink($file);
                    $flag = true;
                };
            }
        }
        if(!$flag) {
            echo "Nothing to delete.<br>";
        }
    }
        
    echo "<h1>Media Cleaner script</h1><hr>\n";
        
    echo "<h3>Linked media</h3>\n";
    $media_links = getMediaLinks($xml_pathes, $site_root);
    arrayList($media_links);
    echo "<h3>Deleted media</h3>\n";
    mediaCleaner($media_pathes, $media_links);
    
?>
        
    </body>
</html>